diff --git a/tests/test_hub/test_edit_channel.py b/tests/test_hub/test_edit_channel.py
index 4196ba3..24c588a 100644
--- a/tests/test_hub/test_edit_channel.py
+++ b/tests/test_hub/test_edit_channel.py
@@ -34,32 +34,28 @@ class TestEditChannel(unittest.TestCase):
         self.exports = kojihub.RootExports()
         self.channel_name = 'test-channel'
         self.channel_name_new = 'test-channel-2'
+        self.channel_info = {'id': 123, 'name': self.channel_name, 'description': 'description',
+                             'comment': 'comment'}
+        self.get_channel = mock.patch('kojihub.get_channel').start()
+        self.verify_name_internal = mock.patch('kojihub.verify_name_internal').start()
 
     def tearDown(self):
         mock.patch.stopall()
 
-    @mock.patch('kojihub.verify_name_internal')
-    @mock.patch('kojihub.get_channel')
-    def test_edit_channel_missing(self, get_channel, verify_name_internal):
+    def test_edit_channel_missing(self):
         expected = 'Invalid type for channelInfo: %s' % self.channel_name
-        get_channel.side_effect = koji.GenericError(expected)
+        self.get_channel.side_effect = koji.GenericError(expected)
         with self.assertRaises(koji.GenericError) as ex:
             self.exports.editChannel(self.channel_name, name=self.channel_name_new)
-        get_channel.assert_called_once_with(self.channel_name, strict=True)
+        self.get_channel.assert_called_once_with(self.channel_name, strict=True)
         self.assertEqual(self.inserts, [])
         self.assertEqual(self.updates, [])
         self.assertEqual(expected, str(ex.exception))
 
-    @mock.patch('kojihub.verify_name_internal')
-    @mock.patch('kojihub.get_channel')
-    def test_edit_channel_already_exists(self, get_channel, verify_name_internal):
-        verify_name_internal.return_value = None
-        get_channel.side_effect = [
-            {
-                'id': 123,
-                'name': self.channel_name,
-                'description': 'description',
-            },
+    def test_edit_channel_already_exists(self):
+        self.verify_name_internal.return_value = None
+        self.get_channel.side_effect = [
+            self.channel_info,
             {
                 'id': 124,
                 'name': self.channel_name_new,
@@ -70,29 +66,22 @@ class TestEditChannel(unittest.TestCase):
             self.exports.editChannel(self.channel_name, name=self.channel_name_new)
         expected_calls = [mock.call(self.channel_name, strict=True),
                           mock.call(self.channel_name_new, strict=False)]
-        get_channel.assert_has_calls(expected_calls)
+        self.get_channel.assert_has_calls(expected_calls)
         self.assertEqual(self.inserts, [])
         self.assertEqual(self.updates, [])
-        self.assertEqual('channel %s already exists (id=124)' % self.channel_name_new,
+        self.assertEqual(f'channel {self.channel_name_new} already exists (id=124)',
                          str(ex.exception))
 
-    @mock.patch('kojihub.verify_name_internal')
-    @mock.patch('kojihub.get_channel')
-    def test_edit_channel_valid(self, get_channel, verify_name_internal):
-        verify_name_internal.return_value = None
-        kojihub.get_channel.side_effect = [{
-            'id': 123,
-            'name': self.channel_name,
-            'description': 'description',
-        },
-            {}]
+    def test_edit_channel_valid(self):
+        self.verify_name_internal.return_value = None
+        kojihub.get_channel.side_effect = [self.channel_info, {}]
 
         r = self.exports.editChannel(self.channel_name, name=self.channel_name_new,
                                      description='description_new')
         self.assertTrue(r)
         expected_calls = [mock.call(self.channel_name, strict=True),
                           mock.call(self.channel_name_new, strict=False)]
-        get_channel.assert_has_calls(expected_calls)
+        self.get_channel.assert_has_calls(expected_calls)
 
         self.assertEqual(len(self.updates), 1)
         values = {'channelID': 123}
@@ -103,21 +92,56 @@ class TestEditChannel(unittest.TestCase):
         self.assertEqual(update.values, values)
         self.assertEqual(update.clauses, clauses)
 
-    @mock.patch('kojihub.verify_name_internal')
-    @mock.patch('kojihub.get_channel')
-    def test_edit_channel_wrong_format(self, get_channel, verify_name_internal):
+    def test_edit_channel_wrong_name(self):
         channel_name_new = 'test-channel+'
-        get_channel.return_value = {'id': 123,
-                                    'name': self.channel_name,
-                                    'description': 'description',
-                                    }
+        self.get_channel.return_value = self.channel_info
 
         # name is longer as expected
-        verify_name_internal.side_effect = koji.GenericError
+        self.verify_name_internal.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             self.exports.editChannel(self.channel_name, name=channel_name_new)
 
         # not except regex rules
-        verify_name_internal.side_effect = koji.GenericError
+        self.verify_name_internal.side_effect = koji.GenericError
+        with self.assertRaises(koji.GenericError):
+            self.exports.editChannel(self.channel_name, name=channel_name_new)
+
+    def test_edit_channel_no_change(self):
+        self.verify_name_internal.return_value = None
+        kojihub.get_channel.return_value = self.channel_info
+
+        r = self.exports.editChannel(self.channel_name, description='description')
+        self.assertFalse(r)
+        self.assertEqual(self.updates, [])
+        self.get_channel.assert_called_once_with(self.channel_name, strict=True)
+        self.verify_name_internal.assert_not_called()
+
+    def test_edit_channel_wrong_format_new_name(self):
+        channel_name_new = 13568
+        self.verify_name_internal.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             self.exports.editChannel(self.channel_name, name=channel_name_new)
+        self.assertEqual(self.updates, [])
+        self.get_channel.assert_called_once_with(self.channel_name, strict=True)
+        self.verify_name_internal.assert_called_once_with(channel_name_new)
+
+    def test_edit_channel_wrong_format_description(self):
+        description = ['description']
+        self.get_channel.return_value = self.channel_info
+        with self.assertRaises(koji.ParameterError) as ex:
+            self.exports.editChannel(self.channel_name, description=description)
+        self.assertEqual(self.updates, [])
+        self.assertEqual(f"Invalid type for value '{description}': {type(description)}",
+                         str(ex.exception))
+        self.get_channel.assert_called_once_with(self.channel_name, strict=True)
+        self.verify_name_internal.assert_not_called()
+
+    def test_edit_channel_wrong_format_comment(self):
+        comment = ['comment']
+        self.get_channel.return_value = self.channel_info
+        with self.assertRaises(koji.ParameterError) as ex:
+            self.exports.editChannel(self.channel_name, comment=comment)
+        self.assertEqual(self.updates, [])
+        self.assertEqual(f"Invalid type for value '{comment}': {type(comment)}", str(ex.exception))
+        self.get_channel.assert_called_once_with(self.channel_name, strict=True)
+        self.verify_name_internal.assert_not_called()
diff --git a/tests/test_hub/test_edit_host.py b/tests/test_hub/test_edit_host.py
index a687bd0..fc9aea5 100644
--- a/tests/test_hub/test_edit_host.py
+++ b/tests/test_hub/test_edit_host.py
@@ -8,7 +8,7 @@ UP = kojihub.UpdateProcessor
 IP = kojihub.InsertProcessor
 
 
-class TestSetHostEnabled(unittest.TestCase):
+class TestEditHost(unittest.TestCase):
     def getInsert(self, *args, **kwargs):
         insert = IP(*args, **kwargs)
         insert.execute = mock.MagicMock()
@@ -22,6 +22,7 @@ class TestSetHostEnabled(unittest.TestCase):
         return update
 
     def setUp(self):
+        self.diff = None
         self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
                                           side_effect=self.getInsert).start()
         self.inserts = []
@@ -34,12 +35,22 @@ class TestSetHostEnabled(unittest.TestCase):
         self.context.session.assertLogin = mock.MagicMock()
         self.context.session.assertPerm = mock.MagicMock()
         self.exports = kojihub.RootExports()
+        self.get_host = mock.patch('kojihub.get_host').start()
+        self.hostinfo = {
+            'id': 123,
+            'user_id': 234,
+            'name': 'hostname',
+            'arches': 'x86_64',
+            'capacity': 100.0,
+            'description': 'description',
+            'comment': 'comment',
+            'enabled': False,
+        }
 
     def tearDown(self):
         mock.patch.stopall()
 
     def test_edit_host_missing(self):
-        kojihub.get_host = mock.MagicMock()
         kojihub.get_host.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             self.exports.editHost('hostname')
@@ -47,23 +58,47 @@ class TestSetHostEnabled(unittest.TestCase):
         self.assertEqual(self.inserts, [])
         self.assertEqual(self.updates, [])
 
+    def test_edit_host_invalid_description(self):
+        description = ['description']
+        kojihub.get_host.return_value = self.hostinfo
+        with self.assertRaises(koji.ParameterError) as ex:
+            self.exports.editHost('hostname', description=description)
+            self.assertEqual('Invalid type for description parameter: %s' % type(description),
+                             str(ex.exception))
+        kojihub.get_host.assert_called_once_with('hostname', strict=True)
+        self.assertEqual(self.inserts, [])
+        self.assertEqual(self.updates, [])
+
+    def test_edit_host_invalid_comment_parameter(self):
+        comment = ['comment']
+        kojihub.get_host.return_value = self.hostinfo
+        with self.assertRaises(koji.ParameterError) as ex:
+            self.exports.editHost('hostname', comment=comment)
+            self.assertEqual('Invalid type for comment parameter: %s' % type(comment),
+                             str(ex.exception))
+        kojihub.get_host.assert_called_once_with('hostname', strict=True)
+        self.assertEqual(self.inserts, [])
+        self.assertEqual(self.updates, [])
+
+    def test_edit_host_invalid_arches_parameter(self):
+        arches = ['arches arches']
+        kojihub.get_host.return_value = self.hostinfo
+        with self.assertRaises(koji.ParameterError) as ex:
+            self.exports.editHost('hostname', arches=arches)
+            self.assertEqual('Invalid type for arches parameter: %s' % type(arches),
+                             str(ex.exception))
+        kojihub.get_host.assert_called_once_with('hostname', strict=True)
+        self.assertEqual(self.inserts, [])
+        self.assertEqual(self.updates, [])
+
     def test_edit_host_valid(self):
         kojihub.get_host = mock.MagicMock()
-        kojihub.get_host.return_value = {
-            'id': 123,
-            'user_id': 234,
-            'name': 'hostname',
-            'arches': ['x86_64'],
-            'capacity': 100.0,
-            'description': 'description',
-            'comment': 'comment',
-            'enabled': False,
-        }
+        kojihub.get_host.return_value = self.hostinfo
         self.context.event_id = 42
         self.context.session.user_id = 23
 
-        r = self.exports.editHost('hostname', arches=['x86_64', 'i386'],
-                capacity=12.0, comment='comment_new', non_existing_kw='bogus')
+        r = self.exports.editHost('hostname', arches='x86_64 i386', capacity=12.0,
+                                  comment='comment_new', non_existing_kw='bogus')
 
         self.assertTrue(r)
         kojihub.get_host.assert_called_once_with('hostname', strict=True)
@@ -87,12 +122,11 @@ class TestSetHostEnabled(unittest.TestCase):
         # insert
         self.assertEqual(len(self.inserts), 1)
         insert = self.inserts[0]
-        #data = kojihub.get_host.return_value
         data = {
             'create_event': 42,
             'creator_id': 23,
             'host_id': 123,
-            'arches': ['x86_64', 'i386'],
+            'arches': 'x86_64 i386',
             'capacity': 12.0,
             'comment': 'comment_new',
             'description': 'description',
@@ -105,16 +139,7 @@ class TestSetHostEnabled(unittest.TestCase):
 
     def test_edit_host_no_change(self):
         kojihub.get_host = mock.MagicMock()
-        kojihub.get_host.return_value = {
-            'id': 123,
-            'user_id': 234,
-            'name': 'hostname',
-            'arches': ['x86_64'],
-            'capacity': 100.0,
-            'description': 'description',
-            'comment': 'comment',
-            'enabled': False,
-        }
+        kojihub.get_host.return_value = self.hostinfo
         self.context.event_id = 42
         self.context.session.user_id = 23
 
diff --git a/tests/test_hub/test_edit_permission.py b/tests/test_hub/test_edit_permission.py
index 39a2d02..0a6b8ff 100644
--- a/tests/test_hub/test_edit_permission.py
+++ b/tests/test_hub/test_edit_permission.py
@@ -42,3 +42,12 @@ class TestEditPermission(unittest.TestCase):
         self.assertEqual(up.table, 'permissions')
         self.assertEqual(up.rawdata, {})
         self.context.session.assertPerm.assert_called_with('admin')
+
+    def test_edit_permission_wrong_type_permission(self):
+        description = ['test-description']
+        with self.assertRaises(koji.GenericError) as ex:
+            self.exports.editPermission(self.perm_name, description=description)
+        self.assertEqual(f"Invalid type for value '{description}': {type(description)}",
+                         str(ex.exception))
+        self.update_processor.assert_not_called()
+        self.context.session.assertPerm.assert_called_with('admin')
diff --git a/tests/test_hub/test_edit_tag.py b/tests/test_hub/test_edit_tag.py
index bc7aa1e..6112047 100644
--- a/tests/test_hub/test_edit_tag.py
+++ b/tests/test_hub/test_edit_tag.py
@@ -236,7 +236,7 @@ WHERE id = %(tagID)i""", {'name': 'newtag', 'tagID': 333})
         with self.assertRaises(koji.GenericError):
             kojihub._edit_tag('tag', **kwargs)
 
-    def test_edit_wrong_format_tag(self):
+    def test_edit_wrong_tag(self):
         tag_name_new = 'new-test-tag+'
         tag_name = 'tag'
         self.get_tag.return_value = {'id': 333,
@@ -268,3 +268,36 @@ WHERE id = %(tagID)i""", {'name': 'newtag', 'tagID': 333})
         self.verify_name_internal.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             kojihub._edit_tag('tag', **kwargs)
+
+    def test_edit_tag_remove_extra_wrong_format(self):
+        kwargs = {
+            'perm': None,
+            'name': 'tag_name_new',
+            'arches': 'arch1 arch2',
+            'locked': True,
+            'maven_support': False,
+            'maven_include_all': False,
+            'extra': {},
+            'remove_extra': 'remove-extra'
+        }
+        with self.assertRaises(koji.ParameterError) as ex:
+            kojihub._edit_tag('tag', **kwargs)
+        self.assertEqual(f"Invalid type for value '{kwargs['remove_extra']}': "
+                         f"{type(kwargs['remove_extra'])}", str(ex.exception))
+
+    def test_edit_tag_block_extra_wrong_format(self):
+        kwargs = {
+            'perm': None,
+            'name': 'tag_name_new',
+            'arches': 'arch1 arch2',
+            'locked': True,
+            'maven_support': False,
+            'maven_include_all': False,
+            'extra': {},
+            'remove_extra': [],
+            'block_extra': 'block-extra'
+        }
+        with self.assertRaises(koji.ParameterError) as ex:
+            kojihub._edit_tag('tag', **kwargs)
+        self.assertEqual(f"Invalid type for value '{kwargs['block_extra']}': "
+                         f"{type(kwargs['block_extra'])}", str(ex.exception))
diff --git a/tests/test_hub/test_edit_tag_external_repo.py b/tests/test_hub/test_edit_tag_external_repo.py
index c96a173..22ff6eb 100644
--- a/tests/test_hub/test_edit_tag_external_repo.py
+++ b/tests/test_hub/test_edit_tag_external_repo.py
@@ -42,8 +42,7 @@ class TestEditTagExternalRepo(unittest.TestCase):
         self.get_tag_external_repos.return_value = []
         with self.assertRaises(koji.GenericError) as cm:
             kojihub.edit_tag_external_repo('tag', 'ext_repo', priority=6, merge_mode='bare')
-        self.assertEqual(cm.exception.args[0],
-                         'external repo ext_repo not associated with tag tag')
+        self.assertEqual('external repo ext_repo not associated with tag tag', str(cm.exception))
         self.get_tag.assert_called_once_with('tag', strict=True)
         self.get_external_repo.assert_called_once_with('ext_repo', strict=True)
         self.get_tag_external_repos.assert_called_once_with(tag_info=1, repo_info=11)
diff --git a/tests/test_hub/test_enable_channel.py b/tests/test_hub/test_enable_channel.py
index b8a3bf6..ac529c7 100644
--- a/tests/test_hub/test_enable_channel.py
+++ b/tests/test_hub/test_enable_channel.py
@@ -29,7 +29,7 @@ class TestEnableChannel(unittest.TestCase):
         self.get_channel.return_value = None
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.enableChannel(self.channelname)
-        self.assertEqual("No such channel: %s" % self.channelname, str(cm.exception))
+        self.assertEqual(f"No such channel: {self.channelname}", str(cm.exception))
 
     def test_valid(self):
         self.get_channel.return_value = {'comment': None, 'description': None,
@@ -42,3 +42,9 @@ class TestEnableChannel(unittest.TestCase):
         self.assertEqual(update.values, {'comment': None, 'description': None, 'enabled': False,
                                          'id': 1, 'name': 'test-channel'})
         self.assertEqual(update.clauses, ['id = %(id)i'])
+
+    def test_wrong_type_channel(self):
+        comment = ['test-comment']
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.enableChannel(self.channelname, comment=comment)
+        self.assertEqual(f"Invalid type for value '{comment}': {type(comment)}", str(cm.exception))
diff --git a/tests/test_hub/test_getRPM.py b/tests/test_hub/test_getRPM.py
index 7d25c55..0f12ce6 100644
--- a/tests/test_hub/test_getRPM.py
+++ b/tests/test_hub/test_getRPM.py
@@ -14,7 +14,7 @@ class TestGetRPM(unittest.TestCase):
         rpminfo = ['test-user']
         with self.assertRaises(koji.GenericError) as cm:
             kojihub.get_rpm(rpminfo)
-        self.assertEqual("Invalid type for rpminfo: %s" % type(rpminfo), str(cm.exception))
+        self.assertEqual(f"Invalid type for rpminfo: {type(rpminfo)}", str(cm.exception))
 
 
 class TestGetRPMHeaders(unittest.TestCase):
@@ -41,7 +41,7 @@ class TestGetRPMHeaders(unittest.TestCase):
         filepath = '../test/path'
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.getRPMHeaders(taskID=99, filepath=filepath)
-        self.assertEqual("Invalid filepath: %s" % filepath, str(cm.exception))
+        self.assertEqual(f"Invalid filepath: {filepath}", str(cm.exception))
         self.get_rpm.assert_not_called()
         self.get_build.assert_not_called()
         self.get_header_fields.assert_not_called()
diff --git a/tests/test_hub/test_get_archive.py b/tests/test_hub/test_get_archive.py
new file mode 100644
index 0000000..05b13bd
--- /dev/null
+++ b/tests/test_hub/test_get_archive.py
@@ -0,0 +1,28 @@
+import unittest
+import mock
+
+import koji
+import kojihub
+
+
+class TestGetArchive(unittest.TestCase):
+
+    def setUp(self):
+        self.maxDiff = None
+        self.list_archives = mock.patch('kojihub.list_archives').start()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_get_archive_non_exist_archive_with_strict(self):
+        archive_id = 1
+        self.list_archives.return_value = []
+        with self.assertRaises(koji.GenericError) as cm:
+            kojihub.get_archive(archive_id, strict=True)
+        self.assertEqual(f"No such archive: {archive_id}", str(cm.exception))
+
+    def test_get_archive_non_exist_archive_without_strict(self):
+        archive_id = 1
+        self.list_archives.return_value = []
+        rv = kojihub.get_archive(archive_id)
+        self.assertEqual(rv, None)
diff --git a/tests/test_hub/test_get_archive_type.py b/tests/test_hub/test_get_archive_type.py
new file mode 100644
index 0000000..bf27b4a
--- /dev/null
+++ b/tests/test_hub/test_get_archive_type.py
@@ -0,0 +1,20 @@
+import unittest
+
+import koji
+import kojihub
+
+
+class TestGetArchiveType(unittest.TestCase):
+
+    def test_get_archive_wrong_type_filename(self):
+        filename = ['test-filename']
+        with self.assertRaises(koji.ParameterError) as cm:
+            kojihub.get_archive_type(filename=filename)
+        self.assertEqual(f"Invalid type for value '{filename}': {type(filename)}",
+                         str(cm.exception))
+
+    def test_get_archive_without_opt(self):
+        with self.assertRaises(koji.GenericError) as cm:
+            kojihub.get_archive_type()
+        self.assertEqual("one of filename, type_name, or type_id must be specified",
+                         str(cm.exception))
diff --git a/tests/test_hub/test_get_build_notification.py b/tests/test_hub/test_get_build_notification.py
new file mode 100644
index 0000000..518e33a
--- /dev/null
+++ b/tests/test_hub/test_get_build_notification.py
@@ -0,0 +1,22 @@
+import mock
+import unittest
+import koji
+import kojihub
+
+
+class TestGetBuildNotification(unittest.TestCase):
+
+    def setUp(self):
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor').start()
+        self.query = self.QueryProcessor.return_value
+        self.exports = kojihub.RootExports()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_empty_result_with_strict(self):
+        notif_id = 1
+        self.query.executeOne.return_value = None
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.getBuildNotification(notif_id, strict=True)
+        self.assertEqual(f"No notification with ID {notif_id} found", str(cm.exception))
diff --git a/tests/test_hub/test_get_build_notification_block.py b/tests/test_hub/test_get_build_notification_block.py
new file mode 100644
index 0000000..1a17072
--- /dev/null
+++ b/tests/test_hub/test_get_build_notification_block.py
@@ -0,0 +1,22 @@
+import mock
+import unittest
+import koji
+import kojihub
+
+
+class TestGetBuildNotificationBlock(unittest.TestCase):
+
+    def setUp(self):
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor').start()
+        self.query = self.QueryProcessor.return_value
+        self.exports = kojihub.RootExports()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_empty_result_with_strict(self):
+        notif_id = 1
+        self.query.executeOne.return_value = None
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.getBuildNotificationBlock(notif_id, strict=True)
+        self.assertEqual(f"No notification block with ID {notif_id} found", str(cm.exception))
diff --git a/tests/test_hub/test_get_build_notification_blocks.py b/tests/test_hub/test_get_build_notification_blocks.py
new file mode 100644
index 0000000..720db8e
--- /dev/null
+++ b/tests/test_hub/test_get_build_notification_blocks.py
@@ -0,0 +1,29 @@
+import mock
+import unittest
+import koji
+import kojihub
+
+
+class TestGetBuildNotificationBlocks(unittest.TestCase):
+    def setUp(self):
+        self.exports = kojihub.RootExports()
+        self.get_user = mock.patch('kojihub.get_user').start()
+        self.get_build_notification_blocks = mock.patch(
+            'kojihub.get_build_notification_blocks').start()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_loggedin_user(self):
+        self.get_user.return_value = {'id': 1}
+        self.exports.getBuildNotificationBlocks(None)
+        self.get_user.assert_called_once_with(None, strict=True)
+        self.get_build_notification_blocks.assert_called_once_with(1)
+
+    def test_user_not_found(self):
+        self.get_user.side_effect = koji.GenericError('error msg')
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.getBuildNotificationBlocks(1)
+        self.get_user.assert_called_once_with(1, strict=True)
+        self.get_build_notification_blocks.assert_not_called()
+        self.assertEqual(cm.exception.args[0], 'error msg')
diff --git a/tests/test_hub/test_get_build_notifications.py b/tests/test_hub/test_get_build_notifications.py
index b4fb176..aba3e97 100644
--- a/tests/test_hub/test_get_build_notifications.py
+++ b/tests/test_hub/test_get_build_notifications.py
@@ -5,18 +5,21 @@ import kojihub
 
 
 class TestGetBuildNotifications(unittest.TestCase):
-    @mock.patch('kojihub.get_user', return_value={'id': 1})
-    @mock.patch('kojihub.get_build_notifications')
-    def test_loggedin_user(self, get_build_notifications, get_user):
+    def setUp(self):
+        self.exports = kojihub.RootExports()
+        self.get_user = mock.patch('kojihub.get_user').start()
+        self.get_build_notifications = mock.patch('kojihub.get_build_notifications').start()
+
+    def test_loggedin_user(self):
+        self.get_user.return_value = {'id': 1}
         kojihub.RootExports().getBuildNotifications(None)
-        get_user.assert_called_once_with(None, strict=True)
-        get_build_notifications.assert_called_once_with(1)
+        self.get_user.assert_called_once_with(None, strict=True)
+        self.get_build_notifications.assert_called_once_with(1)
 
-    @mock.patch('kojihub.get_user', side_effect=koji.GenericError('error msg'))
-    @mock.patch('kojihub.get_build_notifications')
-    def test_user_not_found(self, get_build_notifications, get_user):
+    def test_user_not_found(self):
+        self.get_user.side_effect = koji.GenericError('error msg')
         with self.assertRaises(koji.GenericError) as cm:
             kojihub.RootExports().getBuildNotifications(1)
-        get_user.assert_called_once_with(1, strict=True)
-        get_build_notifications.assert_not_called()
+        self.get_user.assert_called_once_with(1, strict=True)
+        self.get_build_notifications.assert_not_called()
         self.assertEqual(cm.exception.args[0], 'error msg')
diff --git a/tests/test_hub/test_get_changelog_entries.py b/tests/test_hub/test_get_changelog_entries.py
index d75960f..220cf14 100644
--- a/tests/test_hub/test_get_changelog_entries.py
+++ b/tests/test_hub/test_get_changelog_entries.py
@@ -24,13 +24,13 @@ class TestGetChangelogEntries(unittest.TestCase):
         self.get_build.return_value = None
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.getChangelogEntries(buildID=build_id, strict=True)
-        self.assertEqual("No such build: %s" % build_id, str(cm.exception))
+        self.assertEqual(f"No such build: {build_id}", str(cm.exception))
 
     def test_taskid_invalid_path(self):
         filepath = '../test/path'
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.getChangelogEntries(taskID=99, filepath=filepath)
-        self.assertEqual("Invalid filepath: %s" % filepath, str(cm.exception))
+        self.assertEqual(f"Invalid filepath: {filepath}", str(cm.exception))
 
     def test_taskid_without_filepath(self):
         with self.assertRaises(koji.GenericError) as cm:
@@ -43,7 +43,7 @@ class TestGetChangelogEntries(unittest.TestCase):
         self.os_path_exists.return_value = True
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.getChangelogEntries(taskID=99, before=before, filepath=filepath)
-        self.assertEqual("Invalid type for before: %s" % type(before), str(cm.exception))
+        self.assertEqual(f"Invalid type for before: {type(before)}", str(cm.exception))
 
     def test_after_invalid_type(self):
         after = {'after': '1133456'}
@@ -51,7 +51,7 @@ class TestGetChangelogEntries(unittest.TestCase):
         self.os_path_exists.return_value = True
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.getChangelogEntries(taskID=99, after=after, filepath=filepath)
-        self.assertEqual("Invalid type for after: %s" % type(after), str(cm.exception))
+        self.assertEqual(f"Invalid type for after: {type(after)}", str(cm.exception))
 
     def test_srpm_path_not_exist(self):
         filepath = 'test/path'
@@ -62,4 +62,4 @@ class TestGetChangelogEntries(unittest.TestCase):
         self.os_path_exists.return_value = False
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.getChangelogEntries(taskID=task_id, filepath=filepath, strict=True)
-        self.assertEqual("SRPM %s doesn't exist" % srpm_path, str(cm.exception))
+        self.assertEqual(f"SRPM {srpm_path} doesn't exist", str(cm.exception))
diff --git a/tests/test_hub/test_get_external_repo.py b/tests/test_hub/test_get_external_repo.py
index 1880edf..cb687e4 100644
--- a/tests/test_hub/test_get_external_repo.py
+++ b/tests/test_hub/test_get_external_repo.py
@@ -17,7 +17,7 @@ class TestGetExternalRepo(unittest.TestCase):
         self.get_external_repos.return_value = []
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.getExternalRepo(repo, strict=True)
-        self.assertEqual("No such repo: %s" % repo, str(cm.exception))
+        self.assertEqual(f"No such repo: {repo}", str(cm.exception))
 
     def test_non_exist_repo_without_strict(self):
         repo = 'test-repo'
diff --git a/tests/test_hub/test_get_external_repos.py b/tests/test_hub/test_get_external_repos.py
index 25f09fa..6bbd245 100644
--- a/tests/test_hub/test_get_external_repos.py
+++ b/tests/test_hub/test_get_external_repos.py
@@ -1,4 +1,3 @@
-import koji
 import kojihub
 from .utils import DBQueryTestCase
 
@@ -97,9 +96,3 @@ class TestGetExternalRepos(DBQueryTestCase):
         self.assertEqual(rv, [{'id': 1,
                                'name': 'ext_repo_1',
                                'url': 'http://example.com/repo/'}])
-
-    def test_get_external_repos_wrong_type(self):
-        info = {'info_key': 'info_value'}
-        with self.assertRaises(koji.GenericError) as cm:
-            kojihub.get_external_repos(info=info)
-        self.assertEqual("Invalid name or id value: %s" % info, str(cm.exception))
